
package MPlusplus;

import java.awt.*;
import java.awt.event.*;


public class CargarProg extends Frame
{
    TextArea tPrograma;
    Button bAceptar;
    Button bCancelar;
    V_MPlusplus padre;
    Label label1;

    public CargarProg(V_MPlusplus p)
    {
        tPrograma = new TextArea();
        bAceptar = new Button();
        bCancelar = new Button();
        label1 = new Label();
        try
        {
            setTitle("Cargar Programa");
            jbInit();
            padre = p;
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception
    {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation(d.width / 4, d.height / 6);
        setResizable(false);
        this.addComponentListener(new java.awt.event.ComponentAdapter(){
          public void componentResized (ComponentEvent e){
            this_componentResized(e);
          }
        });
        setBackground(Color.lightGray);
        this.setLayout(null);
        this.setSize(new Dimension(400, 310));
        tPrograma.setBounds(new Rectangle(20, 62, 353, 162));
        this.addWindowListener(new java.awt.event.WindowAdapter(){
          public void windowClosing (WindowEvent e){
            this_windowClosing(e);
          }
        });
        bAceptar.setFont(new Font("Arial", 0, 12));
        bAceptar.setBounds(new Rectangle(130, 241, 55, 23));
        bAceptar.setLabel("Aceptar");
        bAceptar.addActionListener(new java.awt.event.ActionListener(){
          public void actionPerformed (ActionEvent e){
            bAceptar_actionPerformed(e);
          }
        });
        bCancelar.setFont(new Font("Arial", 0, 12));
        bCancelar.setBounds(new Rectangle(211, 241, 55, 23));
        bCancelar.setLabel("Cancelar");
        label1.setFont(new Font("Arial", 1, 12));
        label1.setBounds(new Rectangle(20, 36, 78, 26));
        label1.setText("Programa");
        bCancelar.addActionListener(new java.awt.event.ActionListener(){
          public void actionPerformed (ActionEvent e){
            bCancelar_actionPerformed(e);
          }
        });
        this.add(tPrograma, null);
        this.add(bAceptar, null);
        this.add(bCancelar, null);
        this.add(label1, null);
    }

    void bCancelar_actionPerformed(ActionEvent e)
    {
        this.dispose();
    }

    void bAceptar_actionPerformed(ActionEvent e)
    {
        if(!tPrograma.getText().equals(""))
        {
            padre.cargarFichero(tPrograma.getText().trim());
            this.dispose();
        } else
        {
            padre.mostrarVentanaError();
        }
    }

    void this_windowClosing(WindowEvent e)
    {
        this.dispose();
    }

    void this_componentResized(ComponentEvent e)
    {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        this.setLocation(d.width / 4, d.height / 6);
        this.setSize(400, 310);
    }
}