
package MPlusplus;


public class Flags
{
    public int FZ;
    public int FC;
    public byte control;
    public byte FLcar;
    public byte FLbus;
    public V_MPlusplus padre;
    public Conversor conversor;

    public Flags()
    {
        FZ = 0;
        FC = 0;
        control = 0;
        FLcar = 0;
        FLbus = 0;
        conversor = new Conversor();
    }

    public void setpadre(V_MPlusplus m)
    {
        padre = m;
    }

    public void setFLcar(byte fcar)
    {
        FLcar = fcar;
    }

    public byte getFLcar()
    {
        return FLcar;
    }

    public void setFLbus(byte fbus)
    {
        FLbus = fbus;
    }

    public byte getFLbus()
    {
        return FLbus;
    }

    public void setControl(byte c)
    {
        control = c;
    }

    public byte getControl()
    {
        return control;
    }

    public int getFZ()
    {
        return FZ;
    }

    public int getFC()
    {
        return FC;
    }

    public void setFZ(int Z)
    {
        FZ = Z;
    }

    public void setFC(int C)
    {
        FC = C;
    }

    public void simular()
    {
        if(control == 1 && FLcar == 1)
        {
            FZ = padre.alu.getfz();
            FC = padre.alu.getfc();
        }
        if(control == 0 && FLcar == 1)
        {
            int d = padre.Datos;
            String s = conversor.shortToString8((short)d);
            if(s.charAt(0) == '0')
                FZ = 0;
            else
                FZ = 1;
            if(s.charAt(7) == '0')
                FC = 0;
            else
                FC = 1;
        }
        if(FLbus == 1)
        {
            String s;
            if(FZ == 1)
                s = "1"+"000000";
            else
                s = "0"+"000000";
            if(FC == 1)
                s = s + "1";
            else
                s = s + "0";
            int d = conversor.StringToShort(s);
            padre.Datos = d;
        }
    }
}