
package MPlusplus;

import java.awt.*;
import java.awt.event.*;

public class Modificar extends Frame
{

    Panel panel1= new Panel();
    V_MPlusplus padre;
    Panel groupElemento= new Panel();
    Panel groupBox1 = new Panel();
    Label l1= new Label("Elemento a modificar:");
    Label l2 = new Label("Direccin - Valor:");
    TextField tFieldValor= new TextField();
    TextField tFieldDir= new TextField();
    CheckboxGroup checkboxGroup = new CheckboxGroup();
    Checkbox checkboxRegB= new Checkbox();
    Checkbox checkboxRegC= new Checkbox();
    Checkbox checkboxRegD= new Checkbox();
    Checkbox checkboxRegE= new Checkbox();
    Checkbox checkboxAcum= new Checkbox();
    Checkbox checkbox2oper = new Checkbox(); //aadido.
    Checkbox checkboxPCH = new Checkbox(); //aadido.
    Checkbox checkboxPCL = new Checkbox(); //aadido.
    Checkbox checkboxSP = new Checkbox(); //aadido.
    Checkbox checkboxALU= new Checkbox();
    Checkbox checkboxFC= new Checkbox();
    Checkbox checkboxFZ= new Checkbox();
    Checkbox checkboxRegH= new Checkbox();
    Checkbox checkboxRegL= new Checkbox();
    Checkbox checkboxPC= new Checkbox();
    Checkbox checkboxMem= new Checkbox();
    Button botonAceptar= new Button();
    Button botonCancelar= new Button();
    Conversor conversor= new Conversor();
    Scrollbar scrollbar2= new Scrollbar();

    public Modificar(String title, boolean modal)
    {
        try
        {
            jbInit();
            setTitle(title);
            add(panel1);
            pack();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public void setPadre(V_MPlusplus mp)
    {
        padre = mp;
    }

    public void inicializarCampos(String texto)
    {
        botonAceptar.setEnabled(true);
        scrollbar2.setEnabled(false);
        tFieldDir.setEnabled(false);
        tFieldDir.setText("0000");
        tFieldValor.setSize(27, 25);
        tFieldValor.setEnabled(true);
        tFieldValor.setText(texto);
    }

    public boolean validarEntrada()
    {
        String texto = tFieldValor.getText().toUpperCase();
        Checkbox check = checkboxGroup.getSelectedCheckbox();
        if((check == checkboxRegB) || (check == checkboxRegC) || (check == checkboxRegD) || (check == checkboxRegE) || (check == checkboxAcum) || (check == checkboxALU) || (check == checkboxRegH) || (check == checkboxRegL))
            if(texto.length() == 2)
            {
                if(conversor.stringHextoInt(texto) < 256)
                {
                    tFieldValor.setText(texto);
                    return false;
                } else
                {
                    tFieldValor.setText(texto);
                    return true;
                }
            } else
            {
                return true;
            }
        if((check == checkboxFC) || (check == checkboxFZ))
            if(texto.length() == 1)
            {
                if((texto.compareTo("0") == 0) || (texto.compareTo("1") == 0))
                {
                    tFieldValor.setText(texto);
                    return false;
                } else
                {
                    return true;
                }
            } else
            {
                return true;
            }
        if(check == checkboxPC || check == checkboxSP )
            if(texto.length() == 4)
            {
                if(conversor.stringHextoInt(texto) < 65536)
                {
                    tFieldValor.setText(texto);
                    return false;
                } else
                {
                    tFieldValor.setText(texto);
                    return true;
                }
            } else
            {
                return true;
            }
        String textoDir = tFieldDir.getText().toUpperCase();
        if((textoDir.length() == 4) && (texto.length() == 2))
        {
            if((conversor.stringHextoInt(textoDir) < 65536) && (conversor.stringHextoInt(texto) < 256))
            {
                tFieldDir.setText(textoDir);
                tFieldValor.setText(texto);
                return false;
            } else
            {
                tFieldDir.setText(textoDir);
                tFieldValor.setText(texto);
                return true;
            }
        }else
        {
            return true;
        }
    }

    public void jbInit() throws Exception
    {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation(d.width / 4, d.height / 6);
        setSize(344, 280);
        setLayout(null);
        setBackground(Color.lightGray);
        setResizable(false);
        this.addComponentListener(new java.awt.event.ComponentAdapter(){
          public void componentResized (ComponentEvent e){
            this_componentResized(e);
          }
        });
        panel1.setBounds(0, 20, 344, 238);
        groupElemento.setLayout(null);
        groupElemento.setFont(new Font("Dialog", 1, 12));
        groupBox1.setLayout(null);
        groupBox1.setFont(new Font("Dialog", 1, 12));
        tFieldValor.setEnabled(false);
        tFieldValor.setFont(new Font("Dialog", 0, 11));
        tFieldValor.setBounds(new Rectangle(83, 30, 27, 25));
        tFieldValor.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            tFieldValor_actionPerformed(e);
          }
        });
        tFieldDir.setEnabled(false);
        tFieldDir.setFont(new Font("Dialog", 0, 11));
        scrollbar2.setEnabled(false);
        checkboxRegB.setFont(new Font("Dialog", 0, 12));
        checkboxRegB.setLabel("Registro B");
        checkboxRegB.setCheckboxGroup(checkboxGroup);
        checkboxRegB.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxRegB_itemStateChanged(e);
          }
        });
        checkboxRegC.setFont(new Font("Dialog", 0, 12));
        checkboxRegC.setLabel("Registro C");
        checkboxRegC.setCheckboxGroup(checkboxGroup);
	checkboxRegC.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxRegC_itemStateChanged(e);
          }
        });
        checkboxRegD.setFont(new Font("Dialog", 0, 12));
        checkboxRegD.setLabel("Registro D");
        checkboxRegD.setCheckboxGroup(checkboxGroup);
        checkboxRegD.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxRegD_itemStateChanged(e);
          }
        });
        checkboxRegE.setFont(new Font("Dialog", 0, 12));
        checkboxRegE.setLabel("Registro E");
        checkboxRegE.setCheckboxGroup(checkboxGroup);
        checkboxRegE.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxRegE_itemStateChanged(e);
          }
        });
        checkboxAcum.setFont(new Font("Dialog", 0, 12));
        checkboxAcum.setSize(new Dimension(87, 20));
        checkboxAcum.setLabel("Acumulador");
        checkboxAcum.setCheckboxGroup(checkboxGroup);
        checkboxAcum.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxAcum_itemStateChanged(e);
          }
        });
        //aadido.
        checkbox2oper.setFont(new Font("Dialog", 0, 12));
        checkbox2oper.setSize(new Dimension(87, 20));
        checkbox2oper.setLabel("2 Operando");
        checkbox2oper.setCheckboxGroup(checkboxGroup);
        checkbox2oper.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkbox2oper_itemStateChanged(e);
          }
        });
        //aadido.

        //aadido.
        checkboxSP.setFont(new Font("Dialog", 0, 12));
        checkboxSP.setSize(new Dimension(87, 20));
        checkboxSP.setLabel("Stack Pointer");
        checkboxSP.setCheckboxGroup(checkboxGroup);
        checkboxSP.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxSP_itemStateChanged(e);
          }
        });
        //aadido.

        //aadido.
        checkboxPCL.setFont(new Font("Dialog", 0, 12));
        checkboxPCL.setSize(new Dimension(87, 20));
        checkboxPCL.setLabel("PCL");
        checkboxPCL.setCheckboxGroup(checkboxGroup);
        checkboxPCL.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxPCL_itemStateChanged(e);
          }
        });
        //aadido.


        //aadido.
        checkboxPCH.setFont(new Font("Dialog", 0, 12));
        checkboxPCH.setSize(new Dimension(87, 20));
        checkboxPCH.setLabel("PCH");
        checkboxPCH.setCheckboxGroup(checkboxGroup);
        checkboxPCH.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxPCH_itemStateChanged(e);
          }
        });
        //aadido.

        checkboxALU.setVisible(false);
        checkboxALU.setEnabled(false);
        checkboxALU.setFont(new Font("Dialog", 0, 12));
        checkboxALU.setLabel("ALU");
        checkboxALU.setCheckboxGroup(checkboxGroup);
        checkboxALU.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxALU_itemStateChanged(e);
          }
        });
        checkboxFC.setFont(new Font("Dialog", 0, 12));
        checkboxFC.setLabel("Flag C");
        checkboxFC.setCheckboxGroup(checkboxGroup);
        checkboxFC.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxFC_itemStateChanged(e);
          }
        });
        checkboxFZ.setFont(new Font("Dialog", 0, 12));
        checkboxFZ.setLabel("Flag Z");
        checkboxFZ.setCheckboxGroup(checkboxGroup);
        checkboxFZ.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxFZ_itemStateChanged(e);
          }
        });
        checkboxRegH.setFont(new Font("Dialog", 0, 12));
        checkboxRegH.setLabel("Registro H");
        checkboxRegH.setCheckboxGroup(checkboxGroup);
        checkboxRegH.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxRegH_itemStateChanged(e);
          }
        });
        checkboxRegL.setFont(new Font("Dialog", 0, 12));
        checkboxRegL.setLabel("Registro L");
        checkboxRegL.setCheckboxGroup(checkboxGroup);
        checkboxRegL.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxRegL_itemStateChanged(e);
          }
        });
        checkboxPC.setFont(new Font("Dialog", 0, 12));
        checkboxPC.setLabel("PC");
        checkboxPC.setCheckboxGroup(checkboxGroup);
        checkboxPC.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxPC_itemStateChanged(e);
          }
        });
        checkboxMem.setFont(new Font("Dialog", 0, 12));
        checkboxMem.setLabel("Memoria");
        checkboxMem.setCheckboxGroup(checkboxGroup);
        checkboxMem.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxMem_itemStateChanged(e);
          }
        });
        botonAceptar.setLabel("Aceptar");
        botonAceptar.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            botonAceptar_actionPerformed(e);
          }
        });
        botonAceptar.setEnabled(false);
        botonCancelar.setForeground(Color.red);
        botonCancelar.setLabel("Cancelar");
        scrollbar2.setBounds(new Rectangle(48, 10, 15, 40));
        botonCancelar.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            botonCancelar_actionPerformed(e);
          }
        });
        panel1.setLayout(null);
        l1.setBounds(25, 5, 130, 20);
        l1.setFont(new Font("Dialog", 1, 12));
        panel1.add(l1);
        groupElemento.setBounds(25, 19, 324, 100);
        panel1.add(groupElemento);
        checkboxRegB.setBounds(5, 1/*10*/, 87, 26);
        groupElemento.add(checkboxRegB);
        checkboxRegC.setBounds(5, 22/*31*/, 87, 26);
        groupElemento.add(checkboxRegC);
        checkboxRegD.setBounds(5, 43/*52*/, 87, 26);
        groupElemento.add(checkboxRegD);
        checkboxRegE.setBounds(5,63/* 72*/, 87, 26);
        groupElemento.add(checkboxRegE);
        checkboxAcum.setBounds(103, 1/*10*/, 87, 26);
        groupElemento.add(checkboxAcum);
        //aadido.
        checkbox2oper.setBounds(103,22/* 31*/, 87, 26);
        groupElemento.add(checkbox2oper);
        //aadido.
        //aadido.
        checkboxSP.setBounds(5,83/* 92*/, 87, 26);
        groupElemento.add(checkboxSP);
        //aadido.
        //aadido.
        checkboxPCL.setBounds(201, 83/*92*/, 87, 26);
        groupElemento.add(checkboxPCL);
        //aadido.
        //aadido.
        checkboxPCH.setBounds(103, 83/*92*/, 87, 26);
        groupElemento.add(checkboxPCH);
        //aadido.
        checkboxALU.setBounds(201, 72, 87, 26);
        groupElemento.add(checkboxALU);
        checkboxFC.setBounds(201, 1/*10*/, 87, 26);
        groupElemento.add(checkboxFC);
        checkboxFZ.setBounds(201, 22/*31*/, 87, 26);
        groupElemento.add(checkboxFZ);
        checkboxRegH.setBounds(103, 43/*52*/, 87, 26);
        groupElemento.add(checkboxRegH);
        checkboxRegL.setBounds(103, 63/*72*/, 87, 26);
        groupElemento.add(checkboxRegL);
        checkboxPC.setBounds(201, 43/*52*/, 87, 26);
        groupElemento.add(checkboxPC);
        checkboxMem.setBounds(201, 63/*73*/, 87, 26);
        groupElemento.add(checkboxMem);
        l2.setBounds(25, 133, 130, 20);
        l2.setFont(new Font("Dialog", 1, 12));
        panel1.add(l2);
        groupBox1.setBounds(47, 147, 135, 74);
        panel1.add(groupBox1);
        tFieldDir.setBounds(5, 15, 43, 25);
        groupBox1.add(tFieldDir);
        tFieldValor.setBounds(68, 15, 29, 25);
        groupBox1.add(tFieldValor);
        botonAceptar.setBounds(211, 154, 104, 28);
        panel1.add(botonAceptar);
        botonCancelar.setBounds(211, 188, 104, 28);
        panel1.add(botonCancelar);
        groupBox1.add(scrollbar2, null);
        this.addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(WindowEvent e) {
            this_windowClosing(e);
          }
        });
        scrollbar2.setMaximum(65545);
        //scrollbar2.addAdjustmentListener(new Modificar_scrollbar2_adjustmentAdapter(this));
	scrollbar2.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
          public void adjustmentValueChanged(AdjustmentEvent e) {
            scrollbar2_adjustmentValueChanged(e);
          }
        });
        scrollbar2.setValue(0);
    }

    void botonCancelar_actionPerformed(ActionEvent e)
    {
        this.setVisible(false);
        checkboxGroup.setSelectedCheckbox(null);
        tFieldDir.setText("");
        tFieldValor.setText("");
        scrollbar2.setEnabled(false);
        tFieldDir.setEnabled(false);
        tFieldValor.setEnabled(false);
        tFieldValor.setSize(36, 25);
        botonAceptar.setEnabled(false);
    }

    void botonAceptar_actionPerformed(ActionEvent e)
    {
        boolean errorEntrada = validarEntrada();
        if(!errorEntrada)
        {
            this.setVisible(false);
            String textoValor = tFieldValor.getText();
            int valor = conversor.stringHextoInt(textoValor);
            Checkbox check = checkboxGroup.getSelectedCheckbox();
            if(check == checkboxRegB)
                padre.br.setRegB(valor);
            else
            if(check == checkboxRegC)
                padre.br.setRegC(valor);
            else
            if(check == checkboxRegD)
                padre.br.setRegD(valor);
            else
            if(check == checkboxRegE)
                padre.br.setRegE(valor);
            else
            if(check == checkboxAcum)
                padre.A.setValor(valor);
            else
            //aadido.
            if(check == checkbox2oper)
                padre.oper2.setValor(valor);
            else
            //aadido.

            //aadido.
            if(check == checkboxSP)
                padre.sp.setValor(valor);
            else
            //aadido.

            //aadido.
            if(check == checkboxPCL)
                padre.pcl.setValor(valor);
            else
            //aadido.


            //aadido.
            if(check == checkboxPCH)
                padre.pch.setValor(valor);
            else
            //aadido.
            if(check == checkboxALU)
                padre.alu.setValor(valor);
            else
            if(check == checkboxRegH)
                padre.rh.setValor(valor);
            else
            if(check == checkboxRegL)
                padre.rl.setValor(valor);
            else
            if(check == checkboxFC)
                padre.flags.setFC(valor);
            else
            if(check == checkboxFZ)
                padre.flags.setFZ(valor);
            else
            if(check == checkboxPC)
                padre.pc.setValor(valor);
            else
            if(check == checkboxMem)
                padre.mem.setValor(conversor.stringHextoInt(tFieldDir.getText()), valor);
            checkboxGroup.setSelectedCheckbox(null);
            tFieldDir.setText("");
            tFieldValor.setText("");
            scrollbar2.setEnabled(false);
            tFieldDir.setEnabled(false);
            tFieldValor.setEnabled(false);
            tFieldValor.setSize(36, 25);
            botonAceptar.setEnabled(false);
            padre.repaint();
        } else
        {
            tFieldDir.setText("");
            tFieldValor.setText("");
            padre.mostrarVentanaError();
            tFieldDir.requestFocus();
        }
    }

    void checkboxRegB_itemStateChanged(ItemEvent e)
    {
	if(checkboxRegB.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.br.getRegB()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    void checkboxRegC_itemStateChanged(ItemEvent e)
    {	
        if(checkboxRegC.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.br.getRegC()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    void checkboxRegD_itemStateChanged(ItemEvent e)
    {
        if(checkboxRegD.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.br.getRegD()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    void checkboxRegE_itemStateChanged(ItemEvent e)
    {
        if(checkboxRegE.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.br.getRegE()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    void checkboxAcum_itemStateChanged(ItemEvent e)
    {
        if(checkboxAcum.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.A.getValor()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    //aadido.
    void checkbox2oper_itemStateChanged(ItemEvent e)
    {
        if(checkbox2oper.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.oper2.getValor()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }
    //aadido.


    //aadido.
    void checkboxSP_itemStateChanged(ItemEvent e)
    {
        if(checkboxSP.getState())
        {
            inicializarCampos(conversor.shortToHex16((short)padre.sp.getValor()));
            tFieldValor.setSize(36, 25);
        }
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }
    //aadido.

    //aadido.
    void checkboxPCL_itemStateChanged(ItemEvent e)
    {
        if(checkboxPCL.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.pcl.getValor()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }
    //aadido.


    //aadido.
    void checkboxPCH_itemStateChanged(ItemEvent e)
    {
        if(checkboxPCH.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.pch.getValor()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }
    //aadido.

    void checkboxALU_itemStateChanged(ItemEvent e)
    {
        if(checkboxALU.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.alu.getValor()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    void checkboxFC_itemStateChanged(ItemEvent e)
    {
        if(checkboxFC.getState())
        {
            botonAceptar.setEnabled(true);
            scrollbar2.setEnabled(false);
            tFieldDir.setEnabled(false);
            tFieldValor.setSize(16, 25);
            tFieldValor.setEnabled(true);
            tFieldValor.setText(conversor.shortToString1((short)padre.flags.getFC()));
        }
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    void checkboxFZ_itemStateChanged(ItemEvent e)
    {
        if(checkboxFZ.getState())
        {
            botonAceptar.setEnabled(true);
            scrollbar2.setEnabled(false);
            tFieldDir.setEnabled(false);
            tFieldValor.setSize(16, 25);
            tFieldValor.setEnabled(true);
            tFieldValor.setText(conversor.shortToString1((short)padre.flags.getFZ()));
        }
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    void checkboxRegH_itemStateChanged(ItemEvent e)
    {
        if(checkboxRegH.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.rh.getValor()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    void checkboxRegL_itemStateChanged(ItemEvent e)
    {
        if(checkboxRegL.getState())
            inicializarCampos(conversor.shortToHex7((short)padre.rl.getValor()));
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    void checkboxPC_itemStateChanged(ItemEvent e)
    {
        if(checkboxPC.getState())
        {
            inicializarCampos(conversor.shortToHex16((short)padre.pc.getValor()));
            tFieldValor.setSize(36, 25);
        }
        tFieldValor.selectAll();
        tFieldValor.requestFocus();
    }

    void checkboxMem_itemStateChanged(ItemEvent e)
    {
        if(checkboxMem.getState())
        {
            botonAceptar.setEnabled(true);
            scrollbar2.setEnabled(true);
            tFieldDir.setEnabled(true);
            scrollbar2.setValue(0);
            tFieldDir.setText(conversor.shortToHex16((short)scrollbar2.getValue()));
            tFieldValor.setEnabled(true);
            tFieldValor.setSize(27, 25);
            tFieldValor.setText(conversor.shortToHex7((short)padre.mem.getValor(scrollbar2.getValue())));
        }
        tFieldDir.selectAll();
        tFieldDir.requestFocus();
    }

    void scrollbar2_adjustmentValueChanged(AdjustmentEvent e)
    {
        String dir = conversor.shortToHex16((short)scrollbar2.getValue());
        tFieldDir.setText(dir);
        tFieldValor.setText(conversor.shortToHex7((short)padre.mem.getValor(scrollbar2.getValue())));
    }

    void this_windowClosing(WindowEvent e)
    {
        this.setVisible(false);
        checkboxGroup.setSelectedCheckbox(null);
        tFieldDir.setText("");
        tFieldValor.setText("");
        scrollbar2.setEnabled(false);
        tFieldDir.setEnabled(false);
        tFieldValor.setEnabled(false);
        tFieldValor.setSize(36, 25);
        botonAceptar.setEnabled(false);
    }

    void tFieldValor_actionPerformed(ActionEvent e)
    {
        botonAceptar_actionPerformed(e);
    }

    void this_componentResized(ComponentEvent e)
    {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation(d.width / 4, d.height / 6);
        setSize(344, 280);
    }
}