
package MPlus;

public class ALU
{
    public byte control;
    public byte AluBus;
    public int valor;
    public V_MPlus padre;
    public int fz;
    public int fc;
    
    public ALU()
    {
        control = 0;
        AluBus = 0;
        valor = 0;
        fc = 0;
        fz = 0;
    }

    public int getfc()
    {
        return fc;
    }

    public int getfz()
    {
        return fz;
    }

    public void setControl(byte c)
    {
        control = c;
    }

    public byte getControl()
    {
        return control;
    }

    public void setpadre(V_MPlus m)
    {
        padre = m;
    }

    public void setAluBus(byte ab)
    {
        AluBus = ab;
    }

    public void setValor(int v)
    {
        valor = v;
    }

    public byte getAluBus()
    {
        return AluBus;
    }

    public int getValor()
    {
        return valor;
    }

    public int sumar(int val1, int val2)
    {
        int resultado = (int)(val1 + val2);
        if(resultado > 255/*127*/)
            fc = 1;
        else
            fc = 0;
        if(((resultado - 256) == 0) || (resultado == 0))
            fz = 1;
        else
            fz = 0;
        return resultado;
    }

    public int sumar2 (int val1,int val2)
    {
      int resultado;

      resultado = (int)val1 + val2;

      if (resultado > 255 )
      {
        fc = 1;
        resultado = resultado - 256;
      }
      else
      {
         fc = 0;
         resultado = resultado;
      }

      if (resultado == 0)
        fz = 1;
      else
        fz = 0;
      return resultado;
    }

    /*public int restar(int val1, int val2)
    {
        int resultado = (int)(val1 - val2);
        int aux = (int)(val2 ^ 0xff);
        if((val1 + aux++) > 127)
            fc = 1;
        else
            fc = 0;
        if(resultado == 0)
            fz = 1;
        else
            fz = 0;
        return resultado;
    } */

    public int restar2(int val1, int val2)
    {
      int resultado;
      int aux;

      aux = 256 - val2;
      if ( aux == 256)
        aux = 0;

      resultado = val1 + aux;
      if (resultado >= 256 )
      {
        fc = 1;
        resultado = resultado - 256;
      }
      else
      {
         fc = 0;
         resultado = resultado;
      }

      if (resultado == 0)
        fz = 1;
      else
        fz = 0;
      return resultado;
    }
    public int and(int val1, int val2)
    {
        int resultado = val1 & val2;
        if(resultado == 0)
            fz = 1;
        else
            fz = 0;
        return resultado;
    }

    public int or(int val1, int val2)
    {
        int resultado = val1 | val2;
        if(resultado == 0)
            fz = 1;
        else
            fz = 0;
        return resultado;
    }

    public int xor(int val1, int val2)
    {
        int resultado = val1 ^ val2;
        if(resultado == 0)
            fz = 1;
        else
            fz = 0;
        return resultado;
    }

    public int not(int val1)
    {
        int resultado = val1 ^ 0xff;
        if(resultado == 0)
            fz = 1;
        else
            fz = 0;
        return resultado;
    }

    public int pasoB(int val1)
    {
        if(val1 == 0)
            fz = 1;
        else
            fz = 0;
        return val1;
    }

    public int incremento(int val1)
    {
        int resultado = val1 + 1;
        if(resultado > 255)
            fc = 1;
        else
            fc = 0;
        if(((resultado - 256) == 0) || (resultado == 0))
            fz = 1;
        else
            fz = 0;
        return resultado;
    }
    public int incremento2(int val1)
    {
      int resultado;

      resultado = (int)val1 + 1;

      if (resultado > 255 )
      {
        fc = 1;
        resultado = resultado - 256;
      }
      else
      {
         fc = 0;
         resultado = resultado;
      }

      if (resultado == 0)
        fz = 1;
      else
        fz = 0;
      return resultado;
    }

    public void simular()
    {
        int e1 = padre.A.getValor();
        int e2 = padre.oper2.getValor();//Datos;
        switch(control)
        {
        case 0: // '\0'
            //if (padre.estadoActual == 5)/*aqui hay que poner una condicion que evite que se haga la suma en el estado 0 y si en los demas.*/
              valor = sumar2(e1, e2);
            break;

        case 1: // '\001'
            valor = restar2(e1, e2);
            break;

        case 2: // '\002'
            valor = and(e1, e2);
            break;

        case 3: // '\003'
            valor = or(e1, e2);
            break;

        case 4: // '\004'
            valor = xor(e1, e2);
            break;

        case 5: // '\005'
            valor = not(e1);
            break;

        case 6: // '\006'
            valor = pasoB(e2);
            break;

        case 7: // '\007'
            valor = incremento2(e2);
            break;
        }
        if(AluBus == 1)
            padre.Datos = valor;
    }
}
