
package MPlus;


public class Conversor
{

    public Conversor()
    {
    }

    public int stringHextoInt(String texto)
    {
        int valor = 0;
        int resul = 0;
        int pot = 0;
        int i = texto.length() - 1;
        for(i = texto.length() - 1; i >= 0; i--)
        {
            char car = texto.charAt(i);
            switch(car)
            {
            case 'F': // 'F'
                valor = 15;
                break;

            case 'E': // 'E'
                valor = 14;
                break;

            case 'D':
                valor = 13;
                break;

            case 'C':
                valor = 12;
                break;

            case 'B':
                valor = 11;
                break;

            case 'A':
                valor = 10;
                break;

            case '9':
                valor = 9;
                break;

            case '8':
                valor = 8;
                break;

            case '7':
                valor = 7;
                break;

            case '6':
                valor = 6;
                break;

            case '5':
                valor = 5;
                break;

            case '4':
                valor = 4;
                break;

            case '3':
                valor = 3;
                break;

            case '2':
                valor = 2;
                break;

            case '1':
                valor = 1;
                break;

            case '0':
                valor = 0;
                break;
            default:
                resul = Integer.MAX_VALUE;
                break;
            }
            if(resul != Integer.MAX_VALUE)
            {
                resul += valor * (int)Math.pow(16, pot);
                pot++;
            }
        }

        return resul;
    }

    public int stringBintoInt(String texto)
    {
        int valor = 0;
        int resul = 0;
        int pot = 0;
        int i = texto.length() - 1;
        for(i = texto.length() - 1; i >= 0; i--)
        {
            char car = texto.charAt(i);
            switch(car)
            {
            case '1':
                valor = 1;
                break;

            case '0':
                valor = 0;
                break;

            default:
                resul = Integer.MAX_VALUE;
                break;
            }
            if(resul != Integer.MAX_VALUE)
            {
                resul += valor * (int)Math.pow(2, pot);
                pot++;
            }
        }

        return resul;
    }

    public String shortToHex7(short num)
    {
        String texto = "";
        short mascara = 0x000F;
        for(byte i = 0; i < 2; i++)
        {
            short valor = (short)(num & mascara);
            switch(valor)
            {
            case 0: // '\0'
                texto = "0" + texto;
                break;

            case 1: // '\001'
                texto = "1" + texto;
                break;

            case 2: // '\002'
                texto = "2" + texto;
                break;

            case 3: // '\003'
                texto = "3" + texto;
                break;

            case 4: // '\004'
                texto = "4" + texto;
                break;

            case 5: // '\005'
                texto = "5" + texto;
                break;

            case 6: // '\006'
                texto = "6" + texto;
                break;

            case 7: // '\007'
                texto = "7" + texto;
                break;

            case 8: // '\b'
                texto = "8" + texto;
                break;

            case 9: // '\t'
                texto = "9" + texto;
                break;

            case 10: // '\n'
                texto = "A" + texto;
                break;

            case 11: // '\013'
                texto = "B" + texto;
                break;

            case 12: // '\f'
                texto = "C" + texto;
                break;

            case 13: // '\r'
                texto = "D" + texto;
                break;

            case 14: // '\016'
                texto = "E" + texto;
                break;

            case 15: // '\017'
                texto = "F" + texto;
                break;
            }
            num >>>= 4;
        }
        return texto;
    }

    public String shortToHex16(short num)
    {
        String texto = "";
        short mascara = 0x000F;
        for(byte i = 0; i < 4; i++)
        {
            short valor = (short)(num & mascara);
            switch(valor)
            {
            case 0: // '\0'
                texto = "0" + texto;
                break;

            case 1: // '\001'
                texto = "1" + texto;
                break;

            case 2: // '\002'
                texto = "2" + texto;
                break;

            case 3: // '\003'
                texto = "3" + texto;
                break;

            case 4: // '\004'
                texto = "4" + texto;
                break;

            case 5: // '\005'
                texto = "5" + texto;
                break;

            case 6: // '\006'
                texto = "6" + texto;
                break;

            case 7: // '\007'
                texto = "7" + texto;
                break;

            case 8: // '\b'
                texto = "8" + texto;
                break;

            case 9: // '\t'
                texto = "9" + texto;
                break;

            case 10: // '\n'
                texto = "A" + texto;
                break;

            case 11: // '\013'
                texto = "B" + texto;
                break;

            case 12: // '\f'
                texto = "C" + texto;
                break;

            case 13: // '\r'
                texto = "D" + texto;
                break;

            case 14: // '\016'
                texto = "E" + texto;
                break;

            case 15: // '\017'
                texto = "F" + texto;
                break;
            }
            num >>>= 4;
        }
        return texto;
    }

    public String shortToString1(short num)
    {
        String texto = new String();
        if((num & 0x0001) == 0)
            texto = "0";
        else
            texto = "1";
        return texto;
    }

    public String shortToString7(short num)
    {
        String texto = new String();
        short mascara = 0x0001;
        short val = num;
        for(byte i = 0; i < 7; i++)
        {
            if((val & mascara) == 0)
                texto = "0" + texto;
            else
                texto = "1" + texto;
            mascara *= 2;
        }
        return texto;
    }

    public String shortToString8(short num)
    {
        String texto = new String();
        short mascara = 0x0001;
        short val = num;
        for(byte i = 0; i < 8; i++)
        {
            if((val & mascara) == 0)
                texto = "0" + texto;
            else
                texto = "1" + texto;
            mascara *= 2;
        }
        return texto;
    }

    public String shortToString16(short num)
    {
        String texto = new String();
        short mascara = 0x0001;
        short val = num;
        for(byte i = 0; i < 16; i++)
        {
            if((val & mascara) == 0)
                texto = "0" + texto;
            else
                texto = "1" + texto;
            mascara *= 2;
        }
        return texto;
    }

    public byte StringToByte(String texto)
    {
        char uno = '1';
        byte valor = 0;
        byte sumando = 1;
        for(byte i = (byte)(texto.length() - 1); i >= 0; i--)
        {
            if(texto.charAt(i) == uno)
                valor += sumando;
            sumando *= 2;
        }
        return valor;
    }

    public short StringToShort(String texto)
    {
        char uno = '1';
        short valor = 0;
        short sumando = 1;
        for(byte i = (byte)(texto.length() - 1); i >= 0; i--)
        {
            if(texto.charAt(i) == uno)
                valor += sumando;
            sumando *= 2;
        }
        return valor;
    }
}