
package MPlusplus;


public class BancoRegs
{
    public int RegB;
    public int RegC;
    public int RegD;
    public int RegE;
    public int valor;
    public byte SelReg;
    public byte RegCar;
    public byte RegBus;
    public V_MPlusplus padre;
    
    public BancoRegs()
    {
        RegB = 0;
        RegD = 0;
        RegC = 0;
        RegE = 0;
        SelReg = 0;
        RegCar = 0;
        RegBus = 0;
        valor = 0;
    }

    public void setpadre(V_MPlusplus m)
    {
        padre = m;
    }

    public void setRegCar(byte rc)
    {
        RegCar = rc;
    }

    public int getRegB()
    {
        return RegB;
    }

    public int getRegC()
    {
        return RegC;
    }

    public int getRegD()
    {
        return RegD;
    }

    public int getRegE()
    {
        return RegE;
    }

    public byte getRegCar()
    {
        return RegCar;
    }

    public void setSelReg(byte sr)
    {
        SelReg = sr;
    }

    public byte getSelReg()
    {
        return SelReg;
    }

    public void setValor(int v)
    {
        valor = v;
    }

    public int getValor()
    {
        return valor;
    }

    public void simular()
    {
        if(RegCar == 1)
        {
            valor = padre.Datos;
            switch(SelReg)
            {
            case 0: // '\0'
                RegB = valor;
                break;

            case 1: // '\001'
                RegC = valor;
                break;

            case 2: // '\002'
                RegD = valor; //cambiado
                break;

            case 3: // '\003'
                RegE = valor; //cambiado
                break;
            }
        }
        if(RegBus == 1)
        {
            switch(SelReg)
            {
            case 0: // '\0'
                valor = RegB;
                break;

            case 1: // '\001'
                valor = RegC;
                break;

            case 2: // '\002'
                valor = RegD; //cambiado
                break;

            case 3: // '\003'
                valor = RegE; //cambiado
                break;
            }
            padre.Datos = valor;
        }
    }

    public void setRegB(int rb)
    {
        RegB = rb;
    }

    public void setRegC(int rc)
    {
        RegC = rc;
    }

    public void setRegD(int rd)
    {
        RegD = rd;
    }

    public void setRegE(int re)
    {
        RegE = re;
    }

    public void setRegBus(byte rb)
    {
        RegBus = rb;
    }

    public byte getRegBus()
    {
        return RegBus;
    }
}