
package MPlusplus;

import java.awt.*;
import java.awt.event.*;


public class IrA extends Frame
{

    Panel panel1= new Panel();
    V_MPlusplus padre;
    Button botonAceptar= new Button();
    Button botonCancelar= new Button();
    Label label1= new Label();
    TextField tFieldDir= new TextField();
  
    public IrA(String title, boolean modal)
    {
        try
        {
            jbInit();
            setTitle(title);
            add(panel1);
            pack();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public void setPadre(V_MPlusplus mp)
    {
        padre = mp;
    }

    public void jbInit()throws Exception
    {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation(d.width / 4, d.height / 6);
        setSize(263, 220);
        setLayout(null);
        setBackground(Color.lightGray);
        setResizable(false);
        this.addComponentListener(new java.awt.event.ComponentAdapter(){
          public void componentResized (ComponentEvent e){
            this_componentResized(e);
          }
        });
        panel1.setSize(263, 199);
        botonAceptar.setLabel("Aceptar");
        botonAceptar.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            botonAceptar_actionPerformed(e);
          }
        });
        label1.setFont(new Font("Dialog", 1, 14));
        label1.setText("Ir a direccin:");
        tFieldDir.setFont(new Font("Dialog", 0, 11));
        tFieldDir.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            tFieldDir_actionPerformed(e);
          }
        });
        botonCancelar.setForeground(Color.red);
        botonCancelar.setLabel("Cancelar");
        botonCancelar.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            botonCancelar_actionPerformed(e);
          }
        });
        panel1.setLayout(null);
        botonAceptar.setBounds(13, 143, 104, 28);
        panel1.add(botonAceptar);
        botonCancelar.setBounds(123, 143, 104, 28);
        panel1.add(botonCancelar);
        label1.setBounds(29, 63, 104, 31);
        panel1.add(label1);
        tFieldDir.setBounds(141, 62, 43, 25);
        panel1.add(tFieldDir);
        this.addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(WindowEvent e) {
            this_windowClosing(e);
          }
        });
    }

    void botonAceptar_actionPerformed(ActionEvent e)
    {
        String texto = tFieldDir.getText().toUpperCase();
        int dirInt = padre.conversor.stringHextoInt(texto);
        if(texto.length() == 4)
        {
            if(dirInt < 65536)
            {
                setVisible(false);
                tFieldDir.setText("");
                padre.irA = dirInt;
            } else
            {
                tFieldDir.setText(texto);
                padre.mostrarVentanaError();
            }
        } else
        {
            tFieldDir.setText("");
            padre.mostrarVentanaError();
        }
    }

    void botonCancelar_actionPerformed(ActionEvent e)
    {
        this.setVisible(false);
        tFieldDir.setText("");
    }

    void this_windowClosing(WindowEvent e)
    {
        this.setVisible(false);
        tFieldDir.setText("");
    }

    void tFieldDir_actionPerformed(ActionEvent e)
    {
        botonAceptar_actionPerformed(e);
    }

    void this_componentResized(ComponentEvent e)
    {
        setSize(263, 220);
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation(d.width / 4, d.height / 6);
    }
}