
package MPlusplus;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;


public class Simular extends Frame
{
    Panel panel1 = new Panel();
    V_MPlusplus padre;
    TextField tFieldNemonico = new TextField();
    Scrollbar scrollbar1 = new Scrollbar();
    Panel groupBox1 = new Panel();
    CheckboxGroup checkboxGroup = new CheckboxGroup();
    Checkbox checkboxTransf = new Checkbox();
    Checkbox checkboxSalto = new Checkbox();
    Checkbox checkboxArit = new Checkbox();
    Checkbox checkboxLog = new Checkbox();
    Checkbox checkboxFlags = new Checkbox();
    Checkbox checkboxFin = new Checkbox();
    Checkbox checkboxPila = new Checkbox();//aadido
    Checkbox checkboxSubrutina = new Checkbox();//aadido
    TextField tFieldOp1 = new TextField();
    Scrollbar scrollbar2= new Scrollbar();
    TextField tFieldOp2 = new TextField();
    Scrollbar scrollbar3 = new Scrollbar();
    Label labelNem = new Label();
    Label labelOp1 = new Label();
    Label labelOp2 = new Label();
    TextField tFieldCodigo = new TextField();
    Label label1 = new Label();
    Panel groupBox2 = new Panel();
    Button botonAceptar = new Button();
    Button botonCancelar = new Button();
    Label l2 = new Label();
    Label l3 = new Label();
    Conversor conversor = new Conversor();
    Vector codigos = new Vector();

    public Simular(String title, boolean modal)
    {
        l2 = new Label("Tipo de Instruccin:");
        l3 = new Label("Instruccin:");
        try
        {
            jbInit();
            setTitle(title);
            add(panel1);
            pack();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public void setPadre(V_MPlusplus mp)
    {
        padre = mp;
    }

    public boolean validarEntrada()
    {
        String textoNem = tFieldNemonico.getText();
        String textoOp1 = tFieldOp1.getText().toUpperCase();
        if(textoNem.compareTo("MVI") == 0 || textoNem.compareTo("ADI") == 0 || textoNem.compareTo("SUI") == 0 || textoNem.compareTo("CPI") == 0 || textoNem.compareTo("ANI") == 0 || textoNem.compareTo("ORI") == 0 || textoNem.compareTo("XRI") == 0)
            if(textoOp1.length() == 2)
            {
                if(conversor.stringHextoInt(textoOp1) < 256)
                {
                    tFieldOp1.setText(textoOp1);
                    return false;
                } else
                {
                    tFieldOp1.setText(textoOp1);
                    return true;
                }
            } else
            {
                return true;
            }
        if(textoNem.compareTo("LDA") == 0 || textoNem.compareTo("STA") == 0 || textoNem.compareTo("BEQ") == 0 || textoNem.compareTo("BC") == 0 || textoNem.compareTo("JMP") == 0 || textoNem.compareTo("CALL") == 0 || textoNem.compareTo("INISP") == 0)
        {
            if(textoOp1.length() == 4)
            {
                if(conversor.stringHextoInt(textoOp1) < 65536)
                {
                    tFieldOp1.setText(textoOp1);
                    return false;
                } else
                {
                    tFieldOp1.setText(textoOp1);
                    return true;
                }
            } else
            {
                return true;
            }
        } else
        {
            return false;
        }
    }

    public void hab_des_habilitarOp(TextField tf, boolean enabled)
    {
        if(tf == tFieldOp1)
        {
            scrollbar2.setEnabled(enabled);
            tFieldOp1.setEnabled(enabled);
        } else
        {
            scrollbar3.setEnabled(enabled);
            tFieldOp2.setEnabled(false);
        }
    }

    public void ponerTexto(TextField tf, String texto, int ancho, int alto)
    {
        if(tf == tFieldOp1)
            tFieldOp1.setText(texto);
        else
            tFieldOp2.setText(texto);
        tf.setSize(ancho, alto);
    }

    public void inicializar(String texto)
    {
        botonAceptar.setEnabled(true);
        tFieldNemonico.setEnabled(false);
        tFieldNemonico.setText(texto);
        scrollbar1.setEnabled(true);
        scrollbar1.setValue(0);
        hab_des_habilitarOp(tFieldOp1, false);
        hab_des_habilitarOp(tFieldOp2, false);
    }

    public void ponerCodigo(String nem, String op1, String op2)
    {
        Codigo cod = null;
        boolean encontrado = false;
        for(int i = 0; !encontrado && i < codigos.size(); i++)
        {
            cod = (Codigo)codigos.elementAt(i);
            if(cod.getNemonico().compareTo(nem) != 0)
                continue;
            if(cod.getOperando1().compareTo(op1) == 0 && cod.getOperando2().compareTo(op2) == 0)
                encontrado = true;
            if(cod.getOperando1().compareTo("dir") == 0)
                encontrado = true;
            if(cod.getOperando1().compareTo("inm") == 0 && cod.getOperando2().compareTo(op2) == 0)
                encontrado = true;
        }
        if(encontrado)
            tFieldCodigo.setText(cod.getCodigo());
        else
            tFieldCodigo.setText("");
    }

    public void ponerNemonico()
    {
        Checkbox ch = checkboxGroup.getSelectedCheckbox();
        if(ch == checkboxTransf)
            switch(scrollbar1.getValue())
            {
            case 0: // '\0'
                tFieldNemonico.setText("MOV");
                ponerTexto(tFieldOp1, "A", 18, 25);
                ponerTexto(tFieldOp2, "A", 18, 25);
                hab_des_habilitarOp(tFieldOp2, true);
                scrollbar2.setMaximum(14);
                scrollbar3.setMaximum(14);
                scrollbar2.setValue(0);
                scrollbar3.setValue(0);
                tFieldOp1.setEnabled(false);
                scrollbar1.requestFocus();
                break;

            case 1: // '\001'
                tFieldNemonico.setText("MVI");
                ponerTexto(tFieldOp1, "00", 23, 25);
                ponerTexto(tFieldOp2, "A", 18, 25);
                hab_des_habilitarOp(tFieldOp2, true);
                scrollbar3.setMaximum(14);
                scrollbar2.setMaximum(265);
                scrollbar2.setValue(0);
                scrollbar3.setValue(0);
                tFieldOp1.setEnabled(true);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            case 2: // '\002'
                tFieldNemonico.setText("LDA");
                ponerTexto(tFieldOp1, "0000", 38, 25);
                ponerTexto(tFieldOp2, "", 23, 25);
                hab_des_habilitarOp(tFieldOp2, false);
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(65545);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            case 3: // '\003'
                tFieldNemonico.setText("STA");
                ponerTexto(tFieldOp1, "0000", 38, 25);
                ponerTexto(tFieldOp2, "", 23, 25);
                hab_des_habilitarOp(tFieldOp1, true);
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(65545);
                hab_des_habilitarOp(tFieldOp2, false);
                tFieldOp1.setEnabled(true);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            case 4: // '\004'
                tFieldNemonico.setText("LDAX");
                ponerTexto(tFieldOp1, "", 23, 25);
                ponerTexto(tFieldOp2, "", 23, 25);
                hab_des_habilitarOp(tFieldOp1, false);
                tFieldOp1.setEnabled(false);
                scrollbar1.requestFocus();
                break;

            case 5: // '\005'
                tFieldNemonico.setText("STAX");
                ponerTexto(tFieldOp1, "", 23, 25);
                ponerTexto(tFieldOp2, "", 23, 25);
                scrollbar1.requestFocus();
                break;
            }
        else
        if(ch == checkboxSalto)
            switch(scrollbar1.getValue())
            {
            case 0: // '\0'
                tFieldNemonico.setText("BEQ");
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(65545);
                ponerTexto(tFieldOp1, "0000", 38, 25);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            case 1: // '\001'
                tFieldNemonico.setText("BC");
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(65545);
                ponerTexto(tFieldOp1, "0000", 38, 25);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            case 2: // '\002'
                tFieldNemonico.setText("JMP");
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(65545);
                ponerTexto(tFieldOp1, "0000", 38, 25);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;
            }
        else
        if(ch == checkboxArit)
            switch(scrollbar1.getValue())
            {
            case 0: // '\0'
                tFieldNemonico.setText("ADD");
                ponerTexto(tFieldOp1, "A", 18, 25);
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(14);
                tFieldOp1.setEnabled(false);
                scrollbar1.requestFocus();
                break;

            case 1: // '\001'
                tFieldNemonico.setText("SUB");
                ponerTexto(tFieldOp1, "A", 18, 25);
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(14);
                break;

            case 2: // '\002'
                tFieldNemonico.setText("CMP");
                ponerTexto(tFieldOp1, "A", 18, 25);
                tFieldOp1.setEnabled(false);
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(14);
                break;

            case 3: // '\003'
                tFieldNemonico.setText("INR");
                ponerTexto(tFieldOp1, "A", 18, 25);
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(14);
                tFieldOp1.setEnabled(false);
                scrollbar1.requestFocus();
                break;

            case 4: // '\004'
                tFieldNemonico.setText("ADI");
                ponerTexto(tFieldOp1, "00", 23, 25);
                scrollbar2.setMaximum(265);
                scrollbar2.setValue(0);
                tFieldOp1.setEnabled(true);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            case 5: // '\005'
                tFieldNemonico.setText("SUI");
                ponerTexto(tFieldOp1, "00", 23, 25);
                scrollbar2.setMaximum(265);
                scrollbar2.setValue(0);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            case 6: // '\006'
                tFieldNemonico.setText("CPI");
                ponerTexto(tFieldOp1, "00", 23, 25);
                scrollbar2.setMaximum(265);
                scrollbar2.setValue(0);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;
            }
        else
        if(ch == checkboxLog)
            switch(scrollbar1.getValue())
            {
            case 0: // '\0'
                tFieldNemonico.setText("ANA");
                hab_des_habilitarOp(tFieldOp1, true);
                tFieldOp1.setEnabled(false);
                ponerTexto(tFieldOp1, "A", 18, 25);
                scrollbar2.setMaximum(14);
                scrollbar2.setValue(0);
                scrollbar1.requestFocus();
                break;

            case 1: // '\001'
                tFieldNemonico.setText("ORA");
                hab_des_habilitarOp(tFieldOp1, true);
                ponerTexto(tFieldOp1, "A", 18, 25);
                tFieldOp1.setEnabled(false);
                scrollbar2.setMaximum(14);
                scrollbar2.setValue(0);
                break;

            case 2: // '\002'
                tFieldNemonico.setText("XRA");
                hab_des_habilitarOp(tFieldOp1, true);
                tFieldOp1.setEnabled(false);
                ponerTexto(tFieldOp1, "A", 18, 25);
                scrollbar2.setMaximum(14);
                scrollbar2.setValue(0);
                scrollbar1.requestFocus();
                break;

            case 3: // '\003'
                tFieldNemonico.setText("ANI");
                hab_des_habilitarOp(tFieldOp1, true);
                ponerTexto(tFieldOp1, "00", 23, 25);
                scrollbar2.setMaximum(265);
                scrollbar2.setValue(0);
                tFieldOp1.setEnabled(true);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            case 4: // '\004'
                tFieldNemonico.setText("ORI");
                hab_des_habilitarOp(tFieldOp1, true);
                ponerTexto(tFieldOp1, "00", 23, 25);
                scrollbar2.setMaximum(265);
                scrollbar2.setValue(0);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            case 5: // '\005'
                tFieldNemonico.setText("XRI");
                hab_des_habilitarOp(tFieldOp1, true);
                ponerTexto(tFieldOp1, "00", 23, 25);
                scrollbar2.setMaximum(265);
                scrollbar2.setValue(0);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            case 6: // '\006'
                tFieldNemonico.setText("CMA");
                ponerTexto(tFieldOp1, "", 23, 25);
                hab_des_habilitarOp(tFieldOp1, false);
                scrollbar1.requestFocus();
                break;
            }
        else
        if(ch == checkboxFlags)
            switch(scrollbar1.getValue())
            {
            case 0: // '\0'
                tFieldNemonico.setText("LFA");
                tFieldCodigo.setText("81H");
                break;

            case 1: // '\001'
                tFieldNemonico.setText("SFA");
                tFieldCodigo.setText("82H");
                break;
            }
        else
        if(ch == checkboxFin)
            switch(scrollbar1.getValue())
            {
            case 0: // '\0'
                tFieldNemonico.setText("FIN");
                tFieldCodigo.setText("FFH");
                break;
            case 1:
                tFieldNemonico.setText("IRET");
                tFieldCodigo.setText("C0H");
                break;

            }
         else
         if(ch == checkboxPila)   //aadido
            switch(scrollbar1.getValue())
            {
            case 0:
                tFieldNemonico.setText("PUSH");
                ponerTexto(tFieldOp1, "", 23, 25);
                ponerTexto(tFieldOp2, "", 23, 25);
                hab_des_habilitarOp(tFieldOp1, false);
                tFieldOp1.setEnabled(false);
                scrollbar1.requestFocus();
                break;
            case 1: //duda si es as o no
                tFieldNemonico.setText("POP");
                ponerTexto(tFieldOp1, "", 23, 25);
                ponerTexto(tFieldOp2, "", 23, 25);
                hab_des_habilitarOp(tFieldOp1, false);
                tFieldOp1.setEnabled(false);
                scrollbar1.requestFocus();
                 break;
            case 2:
                tFieldNemonico.setText("INISP");
                ponerTexto(tFieldOp1, "0000", 38, 25);
                ponerTexto(tFieldOp2, "", 23, 25);
                hab_des_habilitarOp(tFieldOp2, false);
                hab_des_habilitarOp(tFieldOp1, true);
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(65545);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;

            }
         else
         if(ch == checkboxSubrutina)   //aadido
            switch(scrollbar1.getValue())
            {
            case 0:
                tFieldNemonico.setText("CALL");
                scrollbar2.setValue(0);
                scrollbar2.setMaximum(65545);
                ponerTexto(tFieldOp1, "0000", 38, 25);
                tFieldOp1.selectAll();
                tFieldOp1.requestFocus();
                break;
            case 1:
                tFieldNemonico.setText("RET");
                ponerTexto(tFieldOp1, "", 23, 25);
                ponerTexto(tFieldOp2, "", 23, 25);
                scrollbar1.requestFocus();
                break;
            }

    }

    public void ponerOp1()
    {
        String Nemon = tFieldNemonico.getText().trim();
        Nemon = Nemon.toUpperCase();
        String inm_dir = new String();
        inm_dir = tFieldOp1.getText().trim();
        inm_dir = inm_dir.toUpperCase();
        int i = conversor.stringHextoInt(inm_dir);
        if(Nemon.compareTo("MOV") == 0 || Nemon.compareTo("ADD") == 0 || Nemon.compareTo("SUB") == 0 || Nemon.compareTo("CMP") == 0 || Nemon.compareTo("INR") == 0 || Nemon.compareTo("ANA") == 0 || Nemon.compareTo("ORA") == 0 || Nemon.compareTo("XRA") == 0)
        {
            scrollbar2.setMaximum(14);
            switch(scrollbar2.getValue())
            {
            case 0: // '\0'
                ponerTexto(tFieldOp1, "A", 18, 25);
                break;

            case 1: // '\001'
                ponerTexto(tFieldOp1, "B", 18, 25);
                break;

            case 2: // '\002'
                ponerTexto(tFieldOp1, "C", 18, 25);
                break;

            case 3: // '\003'
                ponerTexto(tFieldOp1, "D", 18, 25);
                break;

            case 4: // '\004'
                ponerTexto(tFieldOp1, "E", 18, 25);
                break;
            }
        } else
        if(Nemon.compareTo("MVI") == 0 || Nemon.compareTo("ADI") == 0 || Nemon.compareTo("SUI") == 0 || Nemon.compareTo("CPI") == 0 || Nemon.compareTo("ANI") == 0 || Nemon.compareTo("ORI") == 0 || Nemon.compareTo("XRI") == 0)
            tFieldOp1.setText(conversor.shortToHex7((short)scrollbar2.getValue()));
        else
        if(Nemon.compareTo("LDA") == 0 || Nemon.compareTo("STA") == 0 || Nemon.compareTo("BEQ") == 0 || Nemon.compareTo("BC") == 0 || Nemon.compareTo("JMP") == 0 || Nemon.compareTo("CALL") == 0 || Nemon.compareTo("INISP") == 0 )
            tFieldOp1.setText(conversor.shortToHex16((short)scrollbar2.getValue()));
    }

    public void ponerOp2()
    {
        scrollbar3.setMaximum(14);
        String Nemon = tFieldNemonico.getText();
        Nemon = Nemon.toUpperCase();
        if(Nemon.compareTo("MOV") == 0 || Nemon.compareTo("MVI") == 0)
            switch(scrollbar3.getValue())
            {
            case 0: // '\0'
                ponerTexto(tFieldOp2, "A", 18, 25);
                break;

            case 1: // '\001'
                ponerTexto(tFieldOp2, "B", 18, 25);
                break;

            case 2: // '\002'
                ponerTexto(tFieldOp2, "C", 18, 25);
                break;

            case 3: // '\003'
                ponerTexto(tFieldOp2, "D", 18, 25);
                break;

            case 4: // '\004'
                ponerTexto(tFieldOp2, "E", 18, 25);
                break;
            }
    }

    public void jbInit() throws Exception
    {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation(d.width / 4, d.height / 6);
        setSize(323, 330);
        setLayout(null);
        setBackground(Color.lightGray);
        setResizable(false);
        this.addComponentListener(new java.awt.event.ComponentAdapter(){
          public void componentResized (ComponentEvent e){
            this_componentResized(e);
          }
        });
        panel1.setBounds(0, 20, 323, 278);
        tFieldNemonico.setEnabled(false);
        tFieldNemonico.setBackground(Color.white);
        tFieldNemonico.setFont(new Font("Dialog", 1, 11));
        scrollbar1.setEnabled(false);
        tFieldOp1.setEnabled(false);
        tFieldOp1.setFont(new Font("Dialog", 0, 11));
        tFieldOp1.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            tFieldOp1_actionPerformed(e);
          }
        });
        scrollbar2.setEnabled(false);
        tFieldOp2.setEnabled(false);
        tFieldOp2.setFont(new Font("Dialog", 0, 11));
        scrollbar3.setEnabled(false);
        labelNem.setFont(new Font("Dialog", 0, 12));
        labelNem.setText("Nemnico");
        labelOp1.setFont(new Font("Dialog", 0, 12));
        labelOp1.setText("Op. 1");
        tFieldCodigo.setEnabled(false);
        tFieldCodigo.setBackground(Color.white);
        tFieldCodigo.setFont(new Font("Dialog", 0, 11));
        tFieldCodigo.setEditable(false);
        label1.setFont(new Font("Dialog", 1, 12));
        label1.setText("Cdigo:");
        l2.setFont(new Font("Dialog", 1, 12));
        l3.setFont(new Font("Dialog", 1, 12));
        groupBox2.setFont(new Font("Dialog", 1, 12));
        groupBox2.setLayout(null);
        botonAceptar.setLabel("Aceptar");
        botonAceptar.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            botonAceptar_actionPerformed(e);
          }
        });
        botonAceptar.setEnabled(false);
        botonCancelar.setForeground(Color.red);
        botonCancelar.setLabel("Cancelar");
        botonCancelar.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            botonCancelar_actionPerformed(e);
          }
        });
        labelOp2.setFont(new Font("Dialog", 0, 12));
        labelOp2.setText("Op. 2");
        groupBox1.setLayout(null);
        groupBox1.setFont(new Font("Dialog", 1, 12));
        checkboxTransf.setFont(new Font("Dialog", 0, 12));
        checkboxTransf.setLabel("Transferencia");
        checkboxTransf.setCheckboxGroup(checkboxGroup);
        checkboxTransf.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxTransf_itemStateChanged(e);
          }
        });
        checkboxSalto.setFont(new Font("Dialog", 0, 12));
        checkboxSalto.setLabel("Salto");
        checkboxSalto.setCheckboxGroup(checkboxGroup);
        checkboxSalto.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxSalto_itemStateChanged(e);
          }
        });
        //aadido
        checkboxPila.setFont(new Font("Dialog", 0, 12));
        checkboxPila.setLabel("Pila");
        checkboxPila.setCheckboxGroup(checkboxGroup);
        checkboxPila.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxPila_itemStateChanged(e);
          }
        });
        //aadido


        //aadido
        checkboxSubrutina.setFont(new Font("Dialog", 0, 12));
        checkboxSubrutina.setLabel("Subrutina");
        checkboxSubrutina.setCheckboxGroup(checkboxGroup);
        checkboxSubrutina.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxSubrutina_itemStateChanged(e);
          }
        });
        //aadido

        checkboxArit.setFont(new Font("Dialog", 0, 12));
        checkboxArit.setLabel("Aritmtica");
        checkboxArit.setCheckboxGroup(checkboxGroup);
        checkboxArit.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxArit_itemStateChanged(e);
          }
        });
        checkboxLog.setFont(new Font("Dialog", 0, 12));
        checkboxLog.setLabel("Lgica");
        checkboxLog.setCheckboxGroup(checkboxGroup);
        checkboxLog.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxLog_itemStateChanged(e);
          }
        });
        checkboxFlags.setFont(new Font("Dialog", 0, 12));
        checkboxFlags.setLabel("Flags");
        checkboxFlags.setCheckboxGroup(checkboxGroup);
        checkboxFlags.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxFlags_itemStateChanged(e);
          }
        });
        checkboxFin.setFont(new Font("Dialog", 0, 12));
        checkboxFin.setLabel("Fin");
        checkboxFin.setCheckboxGroup(checkboxGroup);
        checkboxFin.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            checkboxFin_itemStateChanged(e);
          }
        });
        panel1.setLayout(null);
        l2.setBounds(7, 5, 130, 20);
        panel1.add(l2);
        groupBox1.setBounds(7, 15, 304, 100);
        panel1.add(groupBox1);
        checkboxTransf.setBounds(8, 19, 99, 18);
        groupBox1.add(checkboxTransf);
        //aadido
        checkboxPila.setBounds(8, 71, 79, 18);
        groupBox1.add(checkboxPila);
        //aadido
        //aadido
        checkboxSubrutina.setBounds(120, 71, 79, 18);
        groupBox1.add(checkboxSubrutina);
        //aadido
        checkboxArit.setBounds(120, 19, 76, 18);
        groupBox1.add(checkboxArit);
        checkboxLog.setBounds(215, 19, 61, 18);
        groupBox1.add(checkboxLog);
        checkboxSalto.setBounds(8, 45, 79, 18);
        groupBox1.add(checkboxSalto);
        checkboxFlags.setBounds(120, 45, 72, 18);
        groupBox1.add(checkboxFlags);
        checkboxFin.setBounds(215, 45, 50, 18);
        groupBox1.add(checkboxFin);
        l3.setBounds(7, 113, 100, 20);
        panel1.add(l3);
        groupBox2.setBounds(6, 123, 307, 98);
        panel1.add(groupBox2);
        scrollbar3.setBounds(119, 46, 15, 40);
        groupBox2.add(scrollbar3);
        tFieldNemonico.setBounds(29, 50, 38, 25);
        groupBox2.add(tFieldNemonico);
        scrollbar1.setBounds(13, 43, 15, 40);
        groupBox2.add(scrollbar1);
        tFieldOp1.setBounds(140, 13, 38, 25);
        groupBox2.add(tFieldOp1);
        scrollbar2.setBounds(119, 5, 15, 40);
        groupBox2.add(scrollbar2);
        tFieldOp2.setBounds(140, 55, 38, 25);
        groupBox2.add(tFieldOp2);
        labelNem.setBounds(9, 23, 61, 16);
        groupBox2.add(labelNem);
        labelOp1.setBounds(83, 17, 33, 16);
        groupBox2.add(labelOp1);
        labelOp2.setBounds(83, 57, 37, 16);
        groupBox2.add(labelOp2);
        tFieldCodigo.setBounds(245, 42, 33, 25);
        groupBox2.add(tFieldCodigo);
        label1.setBounds(196, 42, 50, 25);
        groupBox2.add(label1);
        botonAceptar.setBounds(41, 235, 104, 28);
        panel1.add(botonAceptar);
        botonCancelar.setBounds(170, 235, 104, 28);
        panel1.add(botonCancelar);
        this.addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(WindowEvent e) {
            this_windowClosing(e);
          }
        });
        scrollbar1.setMaximum(16);
        scrollbar1.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
          public void adjustmentValueChanged(AdjustmentEvent e) {
            scrollbar1_adjustmentValueChanged(e);
          }
        });
        scrollbar1.setValue(0);
        scrollbar2.setMaximum(14);
        scrollbar2.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
          public void adjustmentValueChanged(AdjustmentEvent e) {
            scrollbar2_adjustmentValueChanged(e);
          }
        });
        scrollbar2.setValue(0);
        scrollbar3.setMaximum(14);
        scrollbar3.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
          public void adjustmentValueChanged(AdjustmentEvent e) {
            scrollbar3_adjustmentValueChanged(e);
          }
        });
        scrollbar3.setValue(0);
        codigos.addElement(new Codigo("MOV", "A", "A", "41H"));
        codigos.addElement(new Codigo("MOV", "B", "A", "10H"));
        codigos.addElement(new Codigo("MOV", "C", "A", "11H"));
        codigos.addElement(new Codigo("MOV", "D", "A", "12H"));
        codigos.addElement(new Codigo("MOV", "E", "A", "13H"));
        codigos.addElement(new Codigo("MOV", "A", "B", "40H"));
        codigos.addElement(new Codigo("MOV", "B", "B", "00H"));
        codigos.addElement(new Codigo("MOV", "C", "B", "01H"));
        codigos.addElement(new Codigo("MOV", "D", "B", "02H"));
        codigos.addElement(new Codigo("MOV", "E", "B", "03H"));
        codigos.addElement(new Codigo("MOV", "A", "C", "44H"));
        codigos.addElement(new Codigo("MOV", "B", "C", "04H"));
        codigos.addElement(new Codigo("MOV", "C", "C", "05H"));
        codigos.addElement(new Codigo("MOV", "D", "C", "06H"));
        codigos.addElement(new Codigo("MOV", "E", "C", "07H"));
        codigos.addElement(new Codigo("MOV", "A", "D", "48H"));
        codigos.addElement(new Codigo("MOV", "B", "D", "08H"));
        codigos.addElement(new Codigo("MOV", "C", "D", "09H"));
        codigos.addElement(new Codigo("MOV", "D", "D", "0AH"));
        codigos.addElement(new Codigo("MOV", "E", "D", "0BH"));
        codigos.addElement(new Codigo("MOV", "A", "E", "4CH"));
        codigos.addElement(new Codigo("MOV", "B", "E", "0CH"));
        codigos.addElement(new Codigo("MOV", "C", "E", "0DH"));
        codigos.addElement(new Codigo("MOV", "D", "E", "0EH"));
        codigos.addElement(new Codigo("MOV", "E", "E", "0FH"));
        codigos.addElement(new Codigo("MVI", "inm", "A", "64H"));
        codigos.addElement(new Codigo("MVI", "inm", "B", "60H"));
        codigos.addElement(new Codigo("MVI", "inm", "C", "61H"));
        codigos.addElement(new Codigo("MVI", "inm", "D", "62H"));
        codigos.addElement(new Codigo("MVI", "inm", "E", "63H"));
        codigos.addElement(new Codigo("LDA", "dir", "", "70H"));
        codigos.addElement(new Codigo("STA", "dir", "", "71H"));
        codigos.addElement(new Codigo("LDAX", "", "", "B0H"));
        codigos.addElement(new Codigo("STAX", "", "", "90H"));
        codigos.addElement(new Codigo("ADI", "inm", "", "65H"));
        codigos.addElement(new Codigo("ADD", "A", "", "42H"));
        codigos.addElement(new Codigo("ADD", "B", "", "30H"));
        codigos.addElement(new Codigo("ADD", "C", "", "31H"));
        codigos.addElement(new Codigo("ADD", "D", "", "32H"));
        codigos.addElement(new Codigo("ADD", "E", "", "33H"));
        codigos.addElement(new Codigo("SUI", "inm", "", "66H"));
        codigos.addElement(new Codigo("SUB", "A", "", "43H"));
        codigos.addElement(new Codigo("SUB", "B", "", "18H"));
        codigos.addElement(new Codigo("SUB", "C", "", "19H"));
        codigos.addElement(new Codigo("SUB", "D", "", "1AH"));
        codigos.addElement(new Codigo("SUB", "E", "", "1BH"));
        codigos.addElement(new Codigo("CPI", "inm", "", "67H"));
        codigos.addElement(new Codigo("CMP", "A", "", "45H"));
        codigos.addElement(new Codigo("CMP", "B", "", "1CH"));
        codigos.addElement(new Codigo("CMP", "C", "", "1DH"));
        codigos.addElement(new Codigo("CMP", "D", "", "1EH"));
        codigos.addElement(new Codigo("CMP", "E", "", "1FH"));
        codigos.addElement(new Codigo("INR", "A", "", "4AH"));
        codigos.addElement(new Codigo("INR", "B", "", "2CH"));
        codigos.addElement(new Codigo("INR", "C", "", "2DH"));
        codigos.addElement(new Codigo("INR", "D", "", "2EH"));
        codigos.addElement(new Codigo("INR", "E", "", "2FH"));
        codigos.addElement(new Codigo("ANI", "inm", "", "68H"));
        codigos.addElement(new Codigo("ANA", "A", "", "46H"));
        codigos.addElement(new Codigo("ANA", "B", "", "20H"));
        codigos.addElement(new Codigo("ANA", "C", "", "21H"));
        codigos.addElement(new Codigo("ANA", "D", "", "22H"));
        codigos.addElement(new Codigo("ANA", "E", "", "23H"));
        codigos.addElement(new Codigo("ORI", "inm", "", "69H"));
        codigos.addElement(new Codigo("ORA", "A", "", "47H"));
        codigos.addElement(new Codigo("ORA", "B", "", "24H"));
        codigos.addElement(new Codigo("ORA", "C", "", "25H"));
        codigos.addElement(new Codigo("ORA", "D", "", "26H"));
        codigos.addElement(new Codigo("ORA", "E", "", "27H"));
        codigos.addElement(new Codigo("XRI", "inm", "", "6AH"));
        codigos.addElement(new Codigo("XRA", "A", "", "49H"));
        codigos.addElement(new Codigo("XRA", "B", "", "28H"));
        codigos.addElement(new Codigo("XRA", "C", "", "29H"));
        codigos.addElement(new Codigo("XRA", "D", "", "2AH"));
        codigos.addElement(new Codigo("XRA", "E", "", "2BH"));
        codigos.addElement(new Codigo("CMA", "", "", "80H"));
        codigos.addElement(new Codigo("BEQ", "dir", "", "72H"));
        codigos.addElement(new Codigo("BC", "dir", "", "73H"));
        codigos.addElement(new Codigo("JMP", "dir", "", "74H"));
        codigos.addElement(new Codigo("LFA", "", "", "81H"));
        codigos.addElement(new Codigo("SFA", "", "", "82H"));
        codigos.addElement(new Codigo("FIN", "", "", "FFH"));
        codigos.addElement(new Codigo("IRET", "", "", "C0H"));
        codigos.addElement(new Codigo("PUSH", "", "", "C1H"));
        codigos.addElement(new Codigo("POP", "", "", "C2H"));
        codigos.addElement(new Codigo("INISP", "dir", "", "C3H"));
        codigos.addElement(new Codigo("CALL", "dir", "", "C4H"));
        codigos.addElement(new Codigo("RET", "", "", "C5H"));
    }

    void botonAceptar_actionPerformed(ActionEvent e)
    {
        boolean errorEntrada = validarEntrada();
        if(!errorEntrada)
        {
            this.setVisible(false);
            String textoNem = tFieldNemonico.getText();
            String textoCod = tFieldCodigo.getText();
            textoCod = textoCod.substring(0, 2);
            String textoOp1 = tFieldOp1.getText();
            String textoAux = null;
            /*
            short aux1 =(short) padre.pch.getValor();
            String high = conversor.shortToString16(aux1);
            aux1 = (short) padre.pcl.getValor();
            String low = conversor.shortToString16(aux1);
            high.concat(low);
            */
            int PCH = padre.pch.getValor();
            int PCL = padre.pcl.getValor();
            String s = conversor.shortToHex7((short)PCH);
            s = s + conversor.shortToHex7((short)PCL);
            int v = conversor.stringHextoInt(s);

            if(textoNem.compareTo("MVI") == 0 || textoNem.compareTo("ADI") == 0 || textoNem.compareTo("SUI") == 0 || textoNem.compareTo("CPI") == 0 || textoNem.compareTo("ANI") == 0 || textoNem.compareTo("ORI") == 0 || textoNem.compareTo("XRI") == 0)
            {
                padre.mem.setValor(v/*padre.pc.getValor()*/, conversor.stringHextoInt(textoCod));
                padre.mem.setValor(v + 1/*padre.pc.getValor()*/ , conversor.stringHextoInt(textoOp1));
            } else
            if(textoNem.compareTo("LDA") == 0 || textoNem.compareTo("STA") == 0 || textoNem.compareTo("BEQ") == 0 || textoNem.compareTo("BC") == 0 || textoNem.compareTo("JMP") == 0 || textoNem.compareTo("CALL") == 0 || textoNem.compareTo("INISP") == 0)
            {
                padre.mem.setValor(v/*padre.pc.getValor()*/, conversor.stringHextoInt(textoCod));
                textoAux = textoOp1.substring(0, 2);
                textoOp1 = textoOp1.substring(2, 4);
                padre.mem.setValor(v + 1/*padre.pc.getValor()*/ , conversor.stringHextoInt(textoAux));
                padre.mem.setValor(v + 2/*padre.pc.getValor() */, conversor.stringHextoInt(textoOp1));
            } else
            if(textoNem.compareTo("FIN") == 0 || textoNem.compareTo("IRET") == 0)
                padre.mem.setValor(v/*padre.pc.getValor()*/, conversor.stringHextoInt(textoCod));
            else
                padre.mem.setValor(v/*padre.pc.getValor()*/, conversor.stringHextoInt(textoCod));
            checkboxGroup.setSelectedCheckbox(null);
            scrollbar1.setEnabled(false);
            tFieldNemonico.setEnabled(false);
            hab_des_habilitarOp(tFieldOp1, false);
            hab_des_habilitarOp(tFieldOp2, false);
            tFieldNemonico.setText("");
            ponerTexto(tFieldOp1, "", 23, 25);
            ponerTexto(tFieldOp2, "", 23, 25);
            tFieldCodigo.setText("");
            botonAceptar.setEnabled(false);
            padre.repaint();
        } else
        {
            tFieldOp1.setText("");
            padre.mostrarVentanaError();
            tFieldOp1.requestFocus();
        }
    }

    void botonCancelar_actionPerformed(ActionEvent e)
    {
        this.setVisible(false);
        checkboxGroup.setSelectedCheckbox(null);
        scrollbar1.setEnabled(false);
        tFieldNemonico.setEnabled(false);
        hab_des_habilitarOp(tFieldOp1, false);
        hab_des_habilitarOp(tFieldOp2, false);
        tFieldNemonico.setText("");
        ponerTexto(tFieldOp1, "", 23, 25);
        ponerTexto(tFieldOp2, "", 23, 25);
        tFieldCodigo.setText("");
        botonAceptar.setEnabled(false);
    }

    void checkboxTransf_itemStateChanged(ItemEvent e)
    {
        inicializar("MOV");
        scrollbar1.setMaximum(15);
        hab_des_habilitarOp(tFieldOp1, true);
        hab_des_habilitarOp(tFieldOp2, true);
        ponerTexto(tFieldOp1, "A", 18, 25);
        ponerTexto(tFieldOp2, "A", 18, 25);
        tFieldCodigo.setText("41H");
        tFieldOp1.setEnabled(false);
    }
     //aadido
    void checkboxPila_itemStateChanged(ItemEvent e)
    {
        inicializar("PUSH");
        scrollbar1.setMaximum(15);
        hab_des_habilitarOp(tFieldOp1, false);
        hab_des_habilitarOp(tFieldOp2, false);
        ponerTexto(tFieldOp1, "", 23, 25);
        ponerTexto(tFieldOp2, "", 23, 25);
        tFieldCodigo.setText("C1H");
        tFieldOp1.setEnabled(false);
    }
      //aadido


      //aadido
    void checkboxSubrutina_itemStateChanged(ItemEvent e)
    {
        inicializar("CALL");
        scrollbar1.setMaximum(12);
        scrollbar2.setMaximum(65545);
        hab_des_habilitarOp(tFieldOp1, true);
        hab_des_habilitarOp(tFieldOp2, false);
        ponerTexto(tFieldOp1, "0000", 38, 25);
        ponerTexto(tFieldOp2, "", 23, 25);
        tFieldCodigo.setText("C4H");
        tFieldOp1.selectAll();
        tFieldOp1.requestFocus();
        hab_des_habilitarOp(tFieldOp1, true);
    }
      //aadido
    void checkboxFin_itemStateChanged(ItemEvent e)
    {
        inicializar("FIN");
        scrollbar1.setMaximum(11);
        hab_des_habilitarOp(tFieldOp1, false);
        hab_des_habilitarOp(tFieldOp2, false);
        ponerTexto(tFieldOp1, "", 23, 25);
        ponerTexto(tFieldOp2, "", 23, 25);
        tFieldCodigo.setText("FFH");
    }

    void checkboxSalto_itemStateChanged(ItemEvent e)
    {
        inicializar("BEQ");
        scrollbar1.setMaximum(12);
        scrollbar2.setMaximum(65545);
        hab_des_habilitarOp(tFieldOp1, true);
        hab_des_habilitarOp(tFieldOp2, false);
        ponerTexto(tFieldOp1, "0000", 38, 25);
        ponerTexto(tFieldOp2, "", 23, 25);
        tFieldCodigo.setText("72H");
        tFieldOp1.selectAll();
        tFieldOp1.requestFocus();
        hab_des_habilitarOp(tFieldOp1, true);
    }

    void checkboxArit_itemStateChanged(ItemEvent e)
    {
        inicializar("ADD");
        scrollbar1.setMaximum(16);
        hab_des_habilitarOp(tFieldOp1, true);
        hab_des_habilitarOp(tFieldOp2, false);
        ponerTexto(tFieldOp1, "A", 18, 25);
        ponerTexto(tFieldOp2, "", 23, 25);
        tFieldCodigo.setText("42H");
        tFieldOp1.setEnabled(false);
    }

    void checkboxLog_itemStateChanged(ItemEvent e)
    {
        inicializar("ANA");
        scrollbar1.setMaximum(16);
        hab_des_habilitarOp(tFieldOp1, true);
        hab_des_habilitarOp(tFieldOp2, false);
        ponerTexto(tFieldOp1, "A", 18, 25);
        ponerTexto(tFieldOp2, "", 23, 25);
        tFieldCodigo.setText("42H");
        tFieldOp1.setEnabled(false);
    }

    void checkboxFlags_itemStateChanged(ItemEvent e)
    {
        inicializar("LFA");
        scrollbar1.setMaximum(11);
        hab_des_habilitarOp(tFieldOp1, false);
        hab_des_habilitarOp(tFieldOp2, false);
        ponerTexto(tFieldOp1, "", 23, 25);
        ponerTexto(tFieldOp2, "", 23, 25);
        tFieldCodigo.setText("81H");
    }

    void scrollbar1_adjustmentValueChanged(AdjustmentEvent e)
    {
        ponerNemonico();
        ponerCodigo(tFieldNemonico.getText(), tFieldOp1.getText(), tFieldOp2.getText());
    }

    void scrollbar2_adjustmentValueChanged(AdjustmentEvent e)
    {
        ponerOp1();
        ponerCodigo(tFieldNemonico.getText(), tFieldOp1.getText(), tFieldOp2.getText());
    }

    void scrollbar3_adjustmentValueChanged(AdjustmentEvent e)
    {
        ponerOp2();
        ponerCodigo(tFieldNemonico.getText(), tFieldOp1.getText(), tFieldOp2.getText());
    }

    void this_windowClosing(WindowEvent e)
    {
        this.setVisible(false);
        checkboxGroup.setSelectedCheckbox(null);
        scrollbar1.setEnabled(false);
        tFieldNemonico.setEnabled(false);
        hab_des_habilitarOp(tFieldOp1, false);
        hab_des_habilitarOp(tFieldOp2, false);
        tFieldNemonico.setText("");
        ponerTexto(tFieldOp1, "", 23, 25);
        ponerTexto(tFieldOp2, "", 23, 25);
        botonAceptar.setEnabled(false);
    }

    void tFieldOp1_actionPerformed(ActionEvent e)
    {
        tFieldOp1.transferFocus();
    }

    void this_componentResized(ComponentEvent e)
    {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation(d.width / 4, d.height / 6);
        setSize(323, 330);
    }
}