
package MPlusplus;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;


public class VentanaError extends Dialog
{
    Panel panel1 = new Panel();
    Button button1 = new Button();
    Label label1 = new Label();
    Label label2 = new Label();

    public VentanaError(Frame frame, String title, boolean modal)
    {
        super(frame, title, modal);
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        add(panel1);
        pack();
    }

    public VentanaError(Frame frame, String title)
    {
        this(frame, title, false);
    }

    public VentanaError(Frame frame)
    {
        this(frame, "", false);
    }

    public void jbInit()
        throws Exception
    {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation(d.width / 4, d.height / 6);
        panel1.setBounds(0, 0, 320, 180);
        setResizable(true);
        button1.setLabel("Aceptar");
        label1.setForeground(Color.red);
        label1.setText("Ha cometido algn ERROR al introducir los datos.");
        label2.setText("Por favor, verifique y corrija los datos.");
        button1.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            button1_actionPerformed(e);
          }
        });
        this.addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(WindowEvent e) {
            this_windowClosing(e);
          }
        });
        panel1.setLayout(null);
        label1.setBounds(20, 40, 275, 16);
        panel1.add(label1);
        label2.setBounds(44, 65, 206, 16);
        panel1.add(label2);
        button1.setBounds(118, 113, 74, 25);
        panel1.add(button1);
    }

    void button1_actionPerformed(ActionEvent e)
    {
        dispose();
    }

    void this_windowClosing(WindowEvent e)
    {
        dispose();
    }
}